diff --git a/examples/minpoly.C b/examples/minpoly.C
index 19badad..132bff9 100644
--- a/examples/minpoly.C
+++ b/examples/minpoly.C
@@ -42,6 +42,8 @@ void printPolynomial (const Field &F, const Polynomial &v)
 
 #include <linbox/ring/modular.h>
 #include <linbox/matrix/sparse-matrix.h>
+#include <linbox/blackbox/diagonal.h>
+#include <linbox/blackbox/compose.h>
 #include <linbox/solutions/minpoly.h>
 
 using namespace LinBox;
@@ -113,9 +115,12 @@ int main (int argc, char **argv)
 		SparseMatrix<Field> B (F);
 		B.read (input);
 		cout << "B is " << B.rowdim() << " by " << B.coldim() << endl;
+		Diagonal<Field> D(F,B.rowdim(),B.rowdim());
+		D.random();
+		Compose<Diagonal<Field>, SparseMatrix<Field> > C(D,B);
 
 		DenseVector<Field> m_B(F);
-		minpoly (m_B, B);
+		minpoly (m_B, C/*B*/);
 
 		cout << "Minimal Polynomial is ";
 		printPolynomial (F, m_B);
